Subject: bug#60311: closed (Re: bug#60311: json-available-p: make dynamically correct for Windows)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 26 Dec 2022 13:31:02 +0000

Your bug report

#60311: json-available-p: make dynamically correct for Windows

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
60311: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=60311
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#60311: json-available-p: make dynamically correct for Windows
From: Eli Zaretskii <[email-masked]>
To: Mattias Engdegård <[email-masked]>
Cc: [email-masked]
Date: Mon, 26 Dec 2022 15:29:58 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Mattias Engdegård <[email-masked]>
> Date: Mon, 26 Dec 2022 13:11:21 +0100
> Cc: [email-masked]
> 
> 25 dec. 2022 kl. 16.40 skrev Eli Zaretskii <[email-masked]>:
> 
> > Yes, you are right.  But please come up with a smaller changeset which
> > only changes what strictly needs to be changed.  Or if you want, I can
> > do this myself.
> 
> Since you have very specific ideas about how to go about it it's better that you make the change yourself.

Done.

> > why not just
> > 
> >  (and (fboundp 'json--available-p)
> >       (json--available-p))
> 
> Calling `fboundp` at run time is wasteful, and that patch used the presence of json--available-p to indicate whether it needs to be called at run time (on Windows only, but it's good to keep that platform-dependency in one place).

Yes, but using eval-when-compile precludes defining json--available-p
at run time, something that I don't like doing in Emacs, since it's
IMO against the Emacs's spirit of being interpreter based.

So I went with the simpler definition that doesn't assume functions
are only defined at byte-compile time.

Thanks, I'm now closing the bug.

Subject: json-available-p: make dynamically correct for Windows
From: Mattias Engdegård <[email-masked]>
To: Emacs Bug Report <[email-masked]>
Date: Sun, 25 Dec 2022 15:32:06 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

The implementation of `json-available-p`,

  (and (fboundp 'json-serialize)
       (condition-case nil
           (json-serialize t)
         (:success t)
         (json-unavailable nil))))

probably isn't quite right on Windows: `json-serialize` is pure so it will be called at compile time and the result, "true", used in the code (actually not even that since the result is never used). Thus, if libjansson could not be loaded during actual Emacs use (as opposed to when Emacs was built), this would never be detected and json-available-p would still return t.

The patch below should take care of this. Would someone please help testing it on Windows?